package util

import groovy.transform.CompileStatic

@CompileStatic
class DockerBuildCommandFactory {

    static String getBuildAdditionalArgs(String dockerfileName) {
        def propertyNames = [
            "docker.build.${dockerfileName.toLowerCase()}.additional-args",
            "docker.build.additional-args"
        ].map { it.toString() }

        return propertyNames.stream()
            .map { CIProperties.findProperty(it).orNull() }
            .filter { it != null }
            .findFirst()
            .orElse("")
    }

    static String getBuildCommand(String dockerfileName, String additionalArgs = "", String context = ".") {
        def dockerCommand = "docker build ${context} -f '${dockerfileName}' ${additionalArgs} ${getBuildAdditionalArgs(dockerfileName)}"
        return dockerCommand
    }

}