package util

import groovy.transform.CompileStatic

@CompileStatic
class Dockerfiles {

    static List<String> getPresetDockerfiles() {
        def preset = CIProperties.findProperty("docker.files.preset")
            .orElse("default")

        def presetDockerfiles = CIProperties.findListProperty("docker.files.${preset}")
            .orElse([])

        if (presetDockerfiles.isEmpty())
            return CIProperties.findListProperty("docker.files")
                    .orElse(["Dockerfile"])
        else
            return presetDockerfiles
    }

    static List<String> getReleaseDockerfiles() {
        return CIProperties.findListProperty("release.artifacts.dockerfiles")
                .orElseGet {
                    CIProperties.findListProperty("gitea.release.artifacts.dockerfiles") // Обратная совместимость
                            .orElseGet {
                                getPresetDockerfiles()
                            }
                }
    }

    static List<String> getDeployDockerfiles() {
        return CIProperties.findListProperty("deploy.dockerfile.names")
                .orElseGet {
                    getPresetDockerfiles()
                }
    }
}
